; http://www.ybnet.fr.st - email: yb_net@yahoo.fr
; Radio chat for TI92 calculators (commentaires traduit en anglais)
; protocole: 87bps, 8bits, 1 start, 1 stop, parity:none.
; (UART logiciel). 
; pinout: red wire=output(bit #0), 
;	  white wire=input(bit #3).
; version dualnet 1.01 for TI92 Fargo II v0.7.2.1
; 
; bug: time base (dependent of batteries' strengh)
;       

 	include "tios.h"	
 	include "flib.h"
 	include "hexlib.h"
 	include "macros.h"   
 	xdef _main
 	xdef _comment

WriteStrA MACRO		 ; Macros used by the  program
 move.w  \3,-(a7)
 move.l  \4,-(a7)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 ENDM



_main:
				; check if 1000 bytes are free
	move.l  #1000,-(a7)		
 	jsr     tios::HeapAlloc		
 	lea     4(a7),a7		
 	cmp     #0,d0
 	beq     OutOfMem
 	move.w  d0,hnum
 	tios::DEREF d0,a0
	move.l  a0,hptr
	
		
        jsr 	flib::clr_scr       	; clear screen
        SetFont #1			; font system=1
	WriteStr #1,#0,#4,titre1	; display infos
 
       	
	clr.b $60000C		; init linking register
        bset.b #6,$60000C       ; direct control mode is actived
        bclr.b #0,$60000E      	 
        bclr.b #1,$60000E	
	 			
	
	move.w	#240,d4
line1:				; draw  the horizontal line
	move.w 	#111,-(a7)	; Coord y
	move.w 	d4,-(a7) 	; Coord x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line1
	
	move.w	#240,d4
line2:				; draw other horizontal line
	move.w 	#9,-(a7)	; Coord y
	move.w 	d4,-(a7) 	; Coord x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line2

	pea	standby(PC)	; display messages in the status bar
	jsr	tios::ST_showHelp
	lea	4(a7),a7

	move.w	#13,index
	move.b	#1,line

main_loop:
	movem.l d0-d4/a0-a6,-(a7)
	pea	standby(PC)	; waiting for text 
	jsr	tios::ST_showHelp ; or message of the partner
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6


wait:
					; loop :waiting for a message
	move.w	(tios::kb_vars+$1E),d0   ;within escape allowed
	clr.w	(tios::kb_vars+$1C)	
	cmp.w	#264,d0
	beq	abort
	cmp.w	#13,d0
	bne	edit		; a key was pressed
	btst.b	#3,$60000E	; waiting for a start-bit	
	bne	reponse0
	bra	wait	; no response, loop is done again
	
reponse0:
	bsr	rcv
	cmp.b	#129,d5
	bne	abort2
	beq	incomming	; message is arriving
	bra	main_loop	; no message

;***********************************
edit:				
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	goedit(PC) 		
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	WriteStr #0,#113,#4,space2	
				; we type the text of the message
	lea     str(PC),a1	; we put a start-byte in the "string"
	movem.l d0-d3,-(a7)
 	move.w	#0,d4
 	move.w	#113,d1		; y coord of text  
 	move.w	#1,d3		; x coord of text
	move.w	#39,d6		; maximum letters writable on a line
	bra 	Input		; d4 receive the number of letters written
suitxt:
	lea     str(PC),a1	; we put a end-byte in the "string"
	lea     0(a1),a4	; we move in a2 (don't ask me how does it works!)
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	connecting(PC)	; we ask if we can send data
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

	move.b	d4,d6		; lengh of the message to send in d6
contacting:
	move.b	#129,d5		; send a request
	bsr	send

	move.b	#9,d4


waiting3:				; ; loop :waiting for a message
	move.w	(tios::kb_vars+$1E),d0   ;within escape allowed
	clr.w	(tios::kb_vars+$1C)	; scans 10 times before send a new request
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; waiting for a start-bit	
	bne	reponse
	dbra	d4,waiting3
	bra	contacting	; no response, loop is done again
	
reponse:
	bsr	rcv
	cmp.b	#6,d5
	bne	abort2

	movem.l d0-d4/a0-a6,-(a7)
	pea	connected(PC)	; we are connected to other partner !
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

				; we send the lengh of the message 
	move.b	d6,d5		
	bsr	send
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	transmitting(PC) ; we send the packet
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	
				
loop:
				; we send the message
	move.b	(a1)+,d5	; packet=message
	bsr	send
	move.w	(tios::kb_vars+$1E),d0 ; escape is allowed
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	bsr	delay2
	dbra	d6,loop		; end of the packet

waiting4:			;  loop :waiting for a byte (escape is allowed)
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; waiting for a start-bit		
	beq	waiting4

	
	bsr	rcv
	cmp.b	#6,d5
	bne	abort2
	

	bsr	delay2
				
	move.b	#56,d5
	bsr	send
	bsr	display

	WriteStr #0,#113,#4,space2	
	bra	main_loop
	
;********************** receive messages ************
incomming:
	movem.l d0-d4/a0-a6,-(a7)
	pea	receiving(PC) 		
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6	
	
	bsr	delay3
	move.b	#6,d5	
	bsr	send
	
longueur:
	bsr	rcv
	move.b	d5,d6		;d5=lengh of the message (<40)
	lea     str(PC),a3
		
message:
	bsr	rcv		; we receive the message
	tst.b	d5	; test of the time_out (because rcv returns 0 if time is out !)
	beq	abort2	; connection lost
	move.b  d5,(a3)+
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	subq.b	#1,d6
	tst.b	d6
	bne	message		; receive the message
	
	clr.b	(a3)
	lea     str(PC),a3
	lea     0(a3),a4	; we store the message...
	bsr	display		; we display the message
	
	bsr	delay3
	move.b	#6,d5		; we answer okay
	bsr	send

	bsr	rcv
	cmp.b	#56,d5		; 56=end of transmition
	beq	main_loop
	bne	abort2		; Errors happend during the transmition...
	bra 	main_loop

;************** routines ***************************

display:
	cmp.w	#109,index
	beq	top1
disp1:
	WriteStrA #1,index,#4,a4 ; displays line
	add.w	#8,index
	add.b	#1,line
	cmp.w	#109,index
	beq	clean1
	WriteStr #1,index,#4,dot
	rts
top1:
	move.w	#13,index
	move.b	#1,line
	bra	disp1
clean1:
	WriteStr #1,#13,#4,dot
	rts

init_interrupt:
	move.w		#$0700,d0
	trap		#1
	move.l		$64,level1_int
	bclr.b		#2,$600001
	move.l		#newint#1,$64
	bset.b		#2,$600001
	trap		#1
	rts

close_interrupt:
	move.w		#$0700,d0
	trap		#1
	bclr.b		#2,$600001
	move.l		level1_int,$64
	bset.b		#2,$600001
	trap		#1
	rts

;***INT #1 : interrupt done 350 times per second around
newint#1:
 add.w   #1,timer
 rte


abort:
	;WriteStr #0,#113,#4,con_nok
	move.l	#0,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	;jsr flib::idle_loop
	;cmp.w	#264,d0
	bra 	exit_prog
abort2:
	movem.l d0-d4/a0-a6,-(a7)
	pea	echec(PC) 		
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6	

	move.l	#0,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	jsr flib::idle_loop
	bra 	main_loop


rcv:	
	move.l	#100000,d3		; UART reception (8bits->d5)
time_in:
	btst.b	#3,$60000E	; waiting for a start-bit with time_out !	
	bne	start
	subq	#1,d3
	tst.l	d3
	bne	time_in
	move.b	#0,d5		; time is out : link error probably
	rts		
start:				; start-bit detected:
	bsr	delay2		; we wait  1.25bit (start-bit+1/4bit D0)
	move.b	#0,d3		; we start a 8 cycle-loop
rcv2:
	btst.b	#3,$60000E	; we read the bit(in its first quarter)
	beq	rcv_un		; we store the bit nx in d5
	bne	rcv_zero
rcv_suite:
	bsr	delay1		 we are waiting for a bit-duration
	move.b	#1,d4		; check if it's the 8th...
	add.b	d4,d3
	cmp.b 	#8,d3
	bne	rcv2		; else loop is done again
	rts			; if it's finished we go away!
	
rcv_zero:			; we store a zero-value in the current bit of d5
	bclr.b	d3,d5		
	bra rcv_suite
rcv_un:
	bset.b	d3,d5		; we store a one-value in D5
	bra rcv_suite

send:				; UART emission (8bits->d5)
	
	bset.b 	#0,$60000E	; 1 start-bit
	bsr 	delay1
	move.b	#0,d3		; we start a loop which is send the 8 bits
lecture:			
	btst.b	d3,d5		; we test the bit nx
	beq	zero		;the bit is 0 -> Z=1 (Z is a 68000's register...)
	bne	un		;the bit is 1 -> Z=0
lect2:	
	move.b	#1,d4
	add.b 	d4,d3
	cmp.b 	#8,d3
	bne	lecture

	bclr.b 	#0,$60000E	; a stop-bit
	bsr 	delay1
	
	rts
				
un:	
	bclr.b 	#0,$60000E	; put the output pinout to 5v level
	bsr 	delay1		
	bra 	lect2
zero:	
	bset.b 	#0,$60000E	; put the output pinout to 0v level
	bsr 	delay1		
	bra 	lect2

delay1:				; loop used to make a 1 bit-duration
	move.w base1,d1
	bra delay_loop
delay2:		
	move.w base2,d1	; loop used to make a 1.5 bit-duration
	bra delay_loop
delay3:		
	move.w base3,d1	; loop used to make a long bit-duration
	bra delay_loop
delay_loop:	
	bsr	init_interrupt
\delay:
	cmp.w   timer,d1	; waiting loop: min=2.857ms(1/350)
 	bgt     \delay
 	clr.w   timer
	bsr	close_interrupt
	rts

exit_prog:
	move.w  hnum,-(a7)			;memory is recovered by the TI92
 	jsr     tios::HeapFree
 	addq    #2,a7
	clr.w   $75B0     
	jsr 	tios::reset_link
 	rts                     ; Exit the program
OutOfMem:
 	rts

Input:
 jsr     flib::idle_loop
 cmp.w	 #264,d0
 beq     abortxt
 bne 	 txtsuit
abortxt:
 movem.l (a7)+,d0-d3
 bra  	abort
txtsuit:
 cmp.w	 #13,d0
 beq     InputDone
 cmp.w	 #257,d0
 beq     BackSpace
 cmp.w   #256,d0
 bcc     Input		;d0=text
 move.b  d0,(a1)+	;d1= y coord of the text
 move.w  d0,d2		; d3/d0?=x coord
 move.w  d3,d0		
 bsr     WriteChar
 addq	 #6,d3
 addq	 #1,d4
 cmp.w   d6,d4		; maximum number writenable
 bne     Input 
 beq 	 InputDone
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a1)
 subq    #6,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 subq    #1,d4
 bra     Input
InputDone:
 clr.b	 (a1)
 movem.l (a7)+,d0-d3
 bra 	suitxt
 
WriteChar:
 movem.l d0-d2/a0,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 jsr     tios::DrawCharXY
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0
 rts

;*********************************************************************************
; Define strings used
titre1 		dc.b    "Single radio chat TI92 (v1.01)",0
request 	dc.b	"Sending request...        [Esc=exit]   ",0
con_nok 	dc.b	"Connection aborted        [Hit any key]",0
connected	dc.b 	"Partner contacted                      ",0
connecting	dc.b 	"Contacting partner...     [Esc=exit]   ",0
waiting_	dc.b 	"Waiting for reply         [Esc]        ",0
receiving	dc.b 	"Receiving message...      [Esc]        ",0
transmitting	dc.b	"Sending message...        [Esc]        ",0
echec		dc.b	"Connection aborted !  Link error [Esc] ",0
standby		dc.b	"Standby   [Esc=exit / Hit any key=edit]",0
goedit		dc.b	"Enter your text.          [Esc=exit]   ",0 
space2		dc.b	"                                        ",0
dot		dc.b	"_                                      ",0

timer		dc.w 0
level1_int	dc.l 0
delayvar 	dc.w 0

hptr     dc.l 0
hnum     dc.w 0


; Define word values to hold status
;basetime	value	speed:	175bps	45bps	87bps
base1	dc.w    4	;	2	8	4
base2	dc.w	6	;	3	10 	6
base3	dc.w    350	
	
index	dc.w	13
line	dc.b	1
str     ds.b 	64


_comment:
        dc.b    "Dualnet for TI92 v1.01",0

        end