; http://www.ybnet.fr.st - email: yb_net@yahoo.fr
; Radio chat for TI92 calculators (commentaires originaux)
; protocole: 87bps, 8bits, 1 start, 1 stop, parity:none.
; (UART logiciel). 
; pinout: red wire=output(bit #0), 
;	  white wire=input(bit #3).
; version dualnet 1.01 for TI92 Fargo II v0.7.2.1
; 
; bug: time base (dependent of batteries' strengh)
;       
 	include "tios.h"	
 	include "flib.h"
 	include "hexlib.h"
 	include "macros.h"   
 	xdef _main
 	xdef _comment

WriteStrA MACRO		 ; Macros used by the  program
 move.w  \3,-(a7)
 move.l  \4,-(a7)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 ENDM



_main:
				; check if 1000 bytes are free
	move.l  #1000,-(a7)		
 	jsr     tios::HeapAlloc		
 	lea     4(a7),a7		
 	cmp     #0,d0
 	beq     OutOfMem
 	move.w  d0,hnum
 	tios::DEREF d0,a0
	move.l  a0,hptr
	
		
        jsr 	flib::clr_scr       	; clear screen
        SetFont #1			; font system=1
	WriteStr #1,#0,#4,titre1	; display infos
 
       	
	clr.b $60000C		; init linking register
        bset.b #6,$60000C       ; direct control mode is actived
        bclr.b #0,$60000E      	 
        bclr.b #1,$60000E	
	 			
	
	move.w	#240,d4
line1:				; draw  the horizontal line
	move.w 	#111,-(a7)	; Coord y
	move.w 	d4,-(a7) 	; Coord x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line1
	
	move.w	#240,d4
line2:				; draw other horizontal line
	move.w 	#9,-(a7)	; Coord y
	move.w 	d4,-(a7) 	; Coord x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line2

	pea	standby(PC)	; display messages in the status bar
	jsr	tios::ST_showHelp
	lea	4(a7),a7

	move.w	#13,index
	move.b	#1,line

main_loop:
	movem.l d0-d4/a0-a6,-(a7)
	pea	standby(PC)	; on attend l'entre du texte 
	jsr	tios::ST_showHelp ; ou d'un message de l'interlocuteur
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6


wait:
					; boucle d'attente reponse hote avec
	move.w	(tios::kb_vars+$1E),d0   ;possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)	
	cmp.w	#264,d0
	beq	abort
	cmp.w	#13,d0
	bne	edit		; on a appuy sur une touche...
	btst.b	#3,$60000E	; attente d'1 bit de start	
	bne	reponse0
	bra	wait	; pas de reponse, a repart pour un tour
	
reponse0:
	bsr	rcv
	cmp.b	#129,d5
	bne	abort2
	beq	incomming	; message de l'interlocuteur
	bra	main_loop	; et biiiieeennnnnnnn non.

;***********************************
edit:				
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	goedit(PC) 		
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	WriteStr #0,#113,#4,space2	
				; on rentre le texte
	lea     str(PC),a1	; on met un caractere de depart
	movem.l d0-d3,-(a7)
 	move.w	#0,d4
 	move.w	#113,d1		; postion y du texte
 	move.w	#1,d3		; postion x du texte
	move.w	#39,d6		; nombre de caracteres maxi retournable
	bra 	Input		; d4 reoit le nombre de caracteres retourns
suitxt:
	lea     str(PC),a1	; on met un caractere de fin
	lea     0(a1),a4	; on transfere dans a2
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	connecting(PC)	; on demande une emission de donnes
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

	move.b	d4,d6		; on met le nombre de caracteres  envoyer dans d6
contacting:
	move.b	#129,d5		; envoi d'une requete
	bsr	send

	move.b	#9,d4
waiting3:				; boucle d'attente reponse hote avec
	move.w	(tios::kb_vars+$1E),d0   ;possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)	; scrute 10 fois avant de relancer une requete
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; attente d'1 bit de start	
	bne	reponse
	dbra	d4,waiting3
	bra	contacting	; pas de reponse, a repart pour un tour
	
reponse:
	bsr	rcv
	cmp.b	#6,d5
	bne	abort2

	movem.l d0-d4/a0-a6,-(a7)
	pea	connected(PC)	; on est connect a l'hote
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

				; on envoi la longueur du message
	move.b	d6,d5		; longueur du packet
	bsr	send
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	transmitting(PC) ; on envoit le packet
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	
				
loop:
				; on envoi le message
	move.b	(a1)+,d5	; packet=message
	bsr	send
	move.w	(tios::kb_vars+$1E),d0 ; on  laisse la possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	bsr	delay2
	dbra	d6,loop		; fin du packet

waiting4:			; boucle d'attente d'un octet avec possibilit d'aborter
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; attente d'1 bit de start	
	beq	waiting4

	
	bsr	rcv
	cmp.b	#6,d5
	bne	abort2
	

	bsr	delay2
				
	move.b	#56,d5
	bsr	send
	bsr	display

	WriteStr #0,#113,#4,space2	
	bra	main_loop
	
;********************** reception des messages ************
incomming:
	movem.l d0-d4/a0-a6,-(a7)
	pea	receiving(PC) 		
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6	
	
	bsr	delay3
	move.b	#6,d5	
	bsr	send
	
longueur:
	bsr	rcv
	move.b	d5,d6		;d5=longueur du message  afficher(<40)
	lea     str(PC),a3
		
message:
	bsr	rcv		; on reoit le message
	tst.b	d5	; test du time_out (car rcv renvoi 0 si time_out !)
	beq	abort2
	move.b  d5,(a3)+
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	subq.b	#1,d6
	tst.b	d6
	bne	message		; reception du message
	
	clr.b	(a3)
	lea     str(PC),a3
	lea     0(a3),a4	; on stocke le message...
	bsr	display		; on affiche le message
	
	bsr	delay3
	move.b	#6,d5		; on previent que c'est receptionner
	bsr	send

	bsr	rcv
	cmp.b	#56,d5		; 56=fin de transmition
	beq	main_loop
	bne	abort2		; il ya une erreur de transmition...
	bra 	main_loop

;************** routines ***************************

display:
	cmp.w	#109,index
	beq	top1
disp1:
	WriteStrA #1,index,#4,a4 ; on affiche la ligne
	add.w	#8,index
	add.b	#1,line
	cmp.w	#109,index
	beq	clean1
	WriteStr #1,index,#4,dot
	rts
top1:
	move.w	#13,index
	move.b	#1,line
	bra	disp1
clean1:
	WriteStr #1,#13,#4,dot
	rts

init_interrupt:
	move.w		#$0700,d0
	trap		#1
	move.l		$64,level1_int
	bclr.b		#2,$600001
	move.l		#newint#1,$64
	bset.b		#2,$600001
	trap		#1
	rts

close_interrupt:
	move.w		#$0700,d0
	trap		#1
	bclr.b		#2,$600001
	move.l		level1_int,$64
	bset.b		#2,$600001
	trap		#1
	rts

;***INT #1 : interruption effectue 350 fois par seconde environ
newint#1:
 add.w   #1,timer
 rte


abort:
	;WriteStr #0,#113,#4,con_nok
	move.l	#0,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	;jsr flib::idle_loop
	;cmp.w	#264,d0
	bra 	exit_prog
abort2:
	movem.l d0-d4/a0-a6,-(a7)
	pea	echec(PC) 		; on reoit la mise  jour de la fenetre...
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6	

	move.l	#0,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	jsr flib::idle_loop
	bra 	main_loop


rcv:	
	move.l	#60000,d3		; UART reception (caractere(8bits)->d5)
time_in:
	btst.b	#3,$60000E	; boucle d'attente d'1 bit de start avec time_out !	
	bne	start
	subq.l	#1,d3
	tst.l	d3
	bne	time_in
	move.b	#0,d5		; time is out : link error probably
	rts		
start:				; bit de start detect:
	bsr	delay2		; on attend 1.25bit(bit de start+1/4bit D0)
	move.b	#0,d3		; on demarre une boucle de 8 cycles
rcv2:
	btst.b	#3,$60000E	; on lit le bit(dans son premier quart)
	beq	rcv_un		; on stocke le bit nx dans d5
	bne	rcv_zero
rcv_suite:
	bsr	delay1		 on attend la duree d'un bit
	move.b	#1,d4		; on regarde si c le 8ieme...
	add.b	d4,d3
	cmp.b 	#8,d3
	bne	rcv2		; si non on recommence
	rts			; si oui on sort de la routine
	
rcv_zero:			; on stocke un zero dans le bit
	bclr.b	d3,d5		; correspondant de d5
	bra rcv_suite
rcv_un:
	bset.b	d3,d5		; on stocke un 1 dans d5
	bra rcv_suite

send:				; UART emission (caractere(8bits)->d5)
	
	bset.b 	#0,$60000E	; 1 bit de start
	bsr 	delay1
	move.b	#0,d3		; on commence la boucle qui va envoyer
lecture:			; les 8 bits de chaque caractere
	btst.b	d3,d5		; on teste le bit nx
	beq	zero		;le bit est 0 -> Z=1
	bne	un		;le bit est 1 -> Z=0
lect2:	
	move.b	#1,d4
	add.b 	d4,d3
	cmp.b 	#8,d3
	bne	lecture

	bclr.b 	#0,$60000E	; 1 bit de stop
	bsr 	delay1
	rts
				
un:	
	bclr.b 	#0,$60000E	; on envoie l'impulsion electrique +5v
	bsr 	delay1		; correspondante
	bra 	lect2
zero:	
	bset.b 	#0,$60000E	; on envoie l'impulsion electrique 0v
	bsr 	delay1		; correspondante
	bra 	lect2

delay1:				; boucle de dure d'un bit
	move.w base1,d1
	bra delay_loop
delay2:		
	move.w base2,d1	; boucle de dure d'un 1.25bit
	bra delay_loop
delay3:		
	move.w base3,d1	; boucle de dure longue
	bra delay_loop
delay_loop:	
	bsr	init_interrupt
\delay:
	cmp.w   timer,d1	; boucle d'attente: minimum=2.857ms(1/350)
 	bgt     \delay
 	clr.w   timer
	bsr	close_interrupt
	rts

exit_prog:
	move.w  hnum,-(a7)			;rends la memoire
 	jsr     tios::HeapFree
 	addq    #2,a7
	clr.w   $75B0     
	jsr 	tios::reset_link
 	rts                     ; Exit the program
OutOfMem:
 	rts

Input:
 jsr     flib::idle_loop
 cmp.w	 #264,d0
 beq     abortxt
 bne 	 txtsuit
abortxt:
 movem.l (a7)+,d0-d3
 bra  	abort
txtsuit:
 cmp.w	 #13,d0
 beq     InputDone
 cmp.w	 #257,d0
 beq     BackSpace
 cmp.w   #256,d0
 bcc     Input		;d0=texte
 move.b  d0,(a1)+	;d1=postion y du texte
 move.w  d0,d2		; d3/d0?=postion x
 move.w  d3,d0		
 bsr     WriteChar
 addq	 #6,d3
 addq	 #1,d4
 cmp.w   d6,d4		; nombre de caracteres maxi
 bne     Input 
 beq 	 InputDone
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a1)
 subq    #6,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 subq    #1,d4
 bra     Input
InputDone:
 clr.b	 (a1)
 movem.l (a7)+,d0-d3
 bra 	suitxt
 
WriteChar:
 movem.l d0-d2/a0,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 jsr     tios::DrawCharXY
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0
 rts

;*********************************************************************************
; Define strings used
titre1 		dc.b    "  ;-) :-O  Dualnet (v1.01)  :-) :-[ ",0
request 	dc.b	"Sending request...        [Esc=exit]   ",0
con_nok 	dc.b	"Connection aborted        [Hit any key]",0
connected	dc.b 	"Partner contacted                      ",0
connecting	dc.b 	"Contacting partner...     [Esc=exit]   ",0
waiting_	dc.b 	"Waiting for reply         [Esc]        ",0
receiving	dc.b 	"Receiving message...      [Esc]        ",0
transmitting	dc.b	"Sending message...         [Esc]        ",0
echec		dc.b	"!!!!!!! LINK ERROR !!!!!!!  [Enter/Esc]",0
standby		dc.b	"Standby   [Esc=exit / Hit any key=edit]",0
goedit		dc.b	"Enter your text.          [Esc=exit]   ",0 
space2		dc.b	"                                        ",0
dot		dc.b	"_                                      ",0

timer		dc.w 0
level1_int	dc.l 0
delayvar 	dc.w 0

hptr     dc.l 0
hnum     dc.w 0


; Define word values to hold status
;basetime	value	speed:	175bps	45bps	87bps
base1	dc.w    4	;	2	8	4
base2	dc.w	6	;	3	10 	6
base3	dc.w    350	
	
index	dc.w	13
line	dc.b	1
str     ds.b 	64



_comment:
        dc.b    "Dualnet for TI92 v1.01",0

        end